const fim_char_t * const FIM_DEFAULT_GRAMMAR_FILE_CONTENTS =
"  program: %empty\n"
"         | statement_list\n"
"\n"
"  statement_list: statement\n"
"                | statement ';' statement_list\n"
"                | non_atomic_statements_block statement_list\n"
"                | statements_block\n"
"\n"
"  non_atomic_statements_block: '{' statement_list '}'\n"
"                             | INTEGER '{' statement_list '}'\n"
"                             | conditional_statement\n"
"\n"
"  statements_block: atomic_statements_block\n"
"                  | non_atomic_statements_block\n"
"\n"
"  conditional_statement: if_statement\n"
"                       | loop_statement\n"
"\n"
"  if_statement: 'if' '(' expression ')' statements_block\n"
"              | 'if' '(' expression ')' statements_block 'else' statements_block\n"
"\n"
"  loop_statement: 'while' '(' expression ')' statements_block\n"
"                | 'do' statements_block 'while' '(' expression ')'\n"
"\n"
"  atomic_statements_block: statement ';'\n"
"                         | statement ';' ';'\n"
"                         | statement ';' ';' ';'\n"
"\n"
"  statement: '!' arguments\n"
"           | INTEGER ',' INTEGER IDENTIFIER\n"
"           | INTEGER ',' INTEGER IDENTIFIER arguments\n"
"           | INTEGER IDENTIFIER\n"
"           | SLASH_AND_REGEXP\n"
"           | '+' UNQUOTED_FLOAT '%'\n"
"           | '+' QUOTED_FLOAT '%'\n"
"           | '+' INTEGER '%'\n"
"           | '*' UNQUOTED_FLOAT\n"
"           | '*' QUOTED_FLOAT\n"
"           | '*' INTEGER\n"
"           | UNQUOTED_FLOAT '%'\n"
"           | QUOTED_FLOAT '%'\n"
"           | INTEGER '%'\n"
"           | '-' UNQUOTED_FLOAT '%'\n"
"           | '-' QUOTED_FLOAT '%'\n"
"           | '-' INTEGER '%'\n"
"           | INTEGER\n"
"           | '-' INTEGER\n"
"           | IDENTIFIER\n"
"           | IDENTIFIER FILE_PATH\n"
"           | IDENTIFIER arguments\n"
"           | INTEGER IDENTIFIER arguments\n"
"           | IDENTIFIER '=' expression\n"
"\n"
"  arguments: expression\n"
"           | expression arguments\n"
"\n"
"  expression: '(' expression ')'\n"
"            | expression '.' expression\n"
"            | '!' expression\n"
"            | expression '%' expression\n"
"            | expression '+' expression\n"
"            | expression '-' expression\n"
"            | expression '*' expression\n"
"            | expression '/' expression\n"
"            | expression '<' expression\n"
"            | expression '>' expression\n"
"            | expression '||' expression\n"
"            | expression BOR expression\n"
"            | expression '&&' expression\n"
"            | expression BAND expression\n"
"            | expression '>=' expression\n"
"            | expression '<=' expression\n"
"            | expression '!=' expression\n"
"            | expression '==' expression\n"
"            | expression '=~' expression\n"
"            | '-' expression\n"
"            | IDENTIFIER\n"
"            | INTEGER\n"
"            | QUOTED_FLOAT\n"
"            | UNQUOTED_FLOAT\n"
"            | STRING\n"
"";
